#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName=lodimages

Function autotrack()
 	setdatafolder root:images
 	string mlist
	variable index,m,cellx,celly,cellz,xoff,yoff,OV,numtimes
	nVar NF=root:numberofframes
	nVar IS=root:imagescale
	nVar CN=root:cellnumber
	nVar MOT=root:movieoftrack
	string folder = "root:cell"+num2str(cn)
	variable check = datafolderexists(folder)
 	index=1
 	mlist=wavelist("W_*",";","")
	cellx=pcsr(a)
	celly=qcsr(a)
	make/o/n=(nf) xposition,yposition,velocity,distance
	velocity[0]=0;distance[0]=0;
	numtimes=1
	if(MOT==0)
 	do
 		string movielist = stringfromlist(index,mlist)
 		if(strlen(movielist)==0)
 			break
 		else
 			duplicate/o $(movielist) test
 			wave test=$""
 		 	Appendimage/w=celltracker/t test
 		 	doupdate
 		 	cursor/h=1/I A test,cellx,celly
 		 	definedark(numtimes)
 		 	numtimes+=1
 		 	cellx=pcsr(a)
 		 	celly=qcsr(a)
 		endif
 		removeimage test
 		index+=1
 	while(1)
	else
	newpath/o/q/z moviepath
	newmovie/i/F=10/p=moviepath
	do
		string Tmovielist = stringfromlist(index,mlist)
		if(strlen(Tmovielist)==0)
			break
		else
			duplicate/o $(Tmovielist) test
			wave test=$""
		 	Appendimage/w=celltracker/t test
		 	doupdate
		 	cursor/h=1/I A test,cellx,celly
		 	definedark(numtimes)
		 	numtimes+=1
		 	cellx=pcsr(a)
		 	celly=qcsr(a)
		 	doupdate
		 	addmovieframe 	
		endif
		removeimage test
		index+=1
	while(1)
	closemovie
	endif
	killwaves/z ypos,xpos,control
	deletepoints 0,2,xposition,yposition,distance,velocity
	make/o/n=1 Tortuosity
	variable straightdist
	wavestats/q xposition
	variable bx,by,ex,ey
	bx=xposition[0];by=yposition[0];ex=xposition[v_npnts-1];ey=yposition[v_npnts-1]
	Tortuosity=sum(distance)/((sqrt((ex-bx)^2+(ey-by)^2))*IS)
	variable timestep
	timestep=1
	movedatatofolder()
	killwaves/z distance,xposition,yposition,velocity,tortuosity
End

Function DefineDark(numtimes)
	variable numtimes
	variable cellx,celly,testx, testy
	nVar D1 = root:Dark
	nVar B1= root:Bright
	nVar IS = root:ImageScale
	nVar FT=root:FrameTime
	cellx=pcsr(a)
	celly=qcsr(a)
	wave test
	Definebox()
	doupdate
	wave control,xpos,ypos,xposition,yposition,distance,velocity//,timex
	wavestats/q control
	variable minx = v_minloc
	variable maxx=v_maxloc
	if(d1==1)
		testx=xpos[minx]
		testy=ypos[minx]
		xposition[numtimes]=xpos[minx]
		yposition[numtimes]=ypos[minx]
		distance[numtimes]=(sqrt((xposition[numtimes]-xposition[numtimes-1])^2 + (yposition[numtimes]-yposition[numtimes-1])^2 ))*IS
		Velocity[numtimes]=distance[numtimes]/FT
	elseif(b1==1)
		testx=xpos[maxx]
		testy=ypos[maxx]
		xposition[numtimes]=xpos[maxx]
		yposition[numtimes]=ypos[maxx]
		distance[numtimes]=(sqrt((xposition[numtimes]-xposition[numtimes-1])^2 + (yposition[numtimes]-yposition[numtimes-1])^2 ))*IS
		Velocity[numtimes]=distance[numtimes]/FT
	endif
	cursor/C=(65535,0,0)/h=1/I A, test, testx, testy
	correctimage(numtimes)
	doupdate
end

Function DefineBox()
	variable a,b,c,d,e,f,g,h,i,holderx,holdery,counter
	variable xoff,yoff,boxpixels,cellx,celly,zerox,zeroy
	nVar Box=root:boxsize
	variable halfbox
	nvar bu=root:binsize  
	halfbox=box/2
	wave test
//	wave w_0000
	xoff=halfbox
	yoff=halfbox
	cellx=pcsr(a)
	celly=qcsr(a)
	zerox=cellx-xoff
	zeroy=celly-yoff
//	print zerox,zeroy
	holderx=zerox
	holdery=zeroy
	killwaves/z control, xpos,ypos	
	make/o/I/n=((halfbox*2)^2) control,xpos,ypos
	counter =0
	e=1

	do
		do
			do	
				do
					control[a]+=test[holderx-(BU/2-.5)][holdery-(BU/2-.5)]
//					cursor/C=(0,0,65535)/I B, W_0000, (holderx-(BU/2-.5)), (holdery-(BU/2-.5))
					b+=1
					holderx+=1
					counter +=1	
					  
				while(b<=BU-1)
				b=0
				holdery+=1
				holderx-=BU
				c+=1	
			while(c<=BU-1)
			c=0
			xpos[a]=zerox
			ypos[a]=zeroy
			zerox+=1
			a+=1
			holdery-=bu
			holderx+=1
			d+=1
		while(d<=(halfbox*2))
		zerox-=box+1
		zeroy+=1
		d=0
		holderx=zerox
		holdery=zeroy//+e
		e+=1
		f+=1
	while(f<=(halfbox*2))	
sort control,control,xpos,ypos
wavestats/q xpos
redimension/n=(v_npnts-1) xpos,ypos,control
//wavestats/q control
//cursor/C=(0,0,65535)/I B, W_0000, xpos[v_minloc], ypos[v_minloc]
end

Function movedatatofolder()
	nVar CN=root:cellnumber
	string savedDF=getdatafolder(1)
	string holder= "root:cell"+num2str(Cn)
	variable check=datafolderexists(holder)
	if(check==0)
		newdatafolder/o/s $(holder)
		duplicate/o Root:Images:distance, distance;duplicate/o Root:Images:velocity, velocity;duplicate/o Root:Images:yposition, yposition;duplicate/o Root:Images:xposition, xposition;
		duplicate/o Root:Images:tortuosity, tortuosity
	else
		setdatafolder $(holder)
		duplicate/o Root:Images:distance, distance;duplicate/o Root:Images:velocity, velocity;duplicate/o Root:Images:yposition, yposition;duplicate/o Root:Images:xposition, xposition;
		duplicate/o Root:Images:tortuosity, tortuosity
	endif
	setdatafolder savedDF
end

function failbox()
	Wave/Z wA = csrwaveref(A)
	if(!WaveExists(wA))
		DoAlert (0), "Place Cursor A and the cell that\ryou can't get to track properly.\rThen click the button again."
		return -1
	else
	endif
	nVar Box=root:boxsize
	variable halfbox,xoff,yoff,cellx,celly
	halfbox=box/2
	xoff=halfbox
	yoff=halfbox
	cellx=pcsr(a)
	celly=qcsr(a)
	variable top, left, right, bottom,numtimes
	top = celly-yoff
	left = cellx-xoff
	right = cellx+xoff
	bottom = celly+yoff
	setdrawlayer progfront
	setdrawenv gstart,gname=maybe
	setdrawenv/W=CellTracker linefgc=(0,0,65535),fillpat=0,xcoord=top,ycoord=left, save
	drawrect/w=CellTracker left,top,right,bottom
end

function successfulbox()
	nvar CN=root:cellnumber
	Wave/Z wA = csrwaveref(A)
	if(!WaveExists(wA))
		DoAlert (0), "Place Cursor A on the cell that\ryou just successfully tracked.\rThen click the button again."
		return -1
	else
	endif
	nVar Box=root:boxsize
	variable halfbox,xoff,yoff,cellx,celly
	halfbox=box/2
	xoff=halfbox
	yoff=halfbox
	cellx=pcsr(a)
	celly=qcsr(a)
	variable top, left, right, bottom,numtimes
	top = celly-yoff
	left = cellx-xoff
	right = cellx+xoff
	bottom = celly+yoff
	setdrawlayer progfront
	setdrawenv gstart,gname=maybe
	setdrawenv/W=Celltracker linefgc=(65535,65535,0),fillpat=0,xcoord=top,ycoord=left, save
	drawrect/w=CellTracker left,top,right,bottom
	setdrawenv gstop	
end

function manualtrack()
string mlist
	variable index,m,numtimes,timestep
	nVar NF=root:numberofframes
	nVar IS=root:imagescale
	nVar cn=root:cellnumber
 	index=1
 	mlist=wavelist("W_*",";","")
 	make/o/n=(nf) xposition,yposition,velocity,distance
	velocity[0]=0;distance[0]=0
	numtimes=1
 	do
 		string movielist = stringfromlist(index,mlist)
 		if(strlen(movielist)==0)
 			break
 		else
 			duplicate/o $(movielist) test
 			wave test=$""
 			Appendimage/w=CellTracker/t test
 			submanualtrack(numtimes)
 			numtimes+=1
 		endif
 		removeimage test
 		index+=1
 	while(1)
 	deletepoints 0,2,xposition,yposition,distance,velocity
 	make/o/n=1 Tortuosity
	variable straightdist
	wavestats/q xposition
	variable bx,by,ex,ey
	bx=xposition[0];by=yposition[0];ex=xposition[v_npnts-1];ey=yposition[v_npnts-1]
	Tortuosity=sum(distance)/((sqrt((ex-bx)^2+(ey-by)^2))*IS)
	timestep=1
	movedatatofolder()
	killwaves/z distance,xposition,yposition,velocity,tortuosity
end

function SubManualTrack(numtimes)
	variable numtimes
	variable cellx,celly
	nVar IS = root:ImageScale
	nVar FT=root:FrameTime
	wave xposition,yposition,velocity,distance,timex
	NewPanel /K=2 /W=(187,368,437,531) as "Pause for New Cell Position"
	DoWindow/C tmp_PauseforCursor					// Set to an unlikely name
	AutoPositionWindow/E/M=1/R=CellTracker		// Put panel near the graph
	DrawText 21,20,"Set cursor A on new cell position"
	DrawText 21,40,"and then click Continue."
	Button button0,pos={80,58},size={92,20},title="Continue"
	Button button0,proc=UserAdjust_ContButtonProc
	PauseForUser tmp_PauseforCursor,CellTracker
	cellx=pcsr(a)
	celly=qcsr(a)
	xposition[numtimes]=cellx
	yposition[numtimes]=celly
	distance[numtimes]=(sqrt((xposition[numtimes]-xposition[numtimes-1])^2 + (yposition[numtimes]-yposition[numtimes-1])^2 ))*IS
	Velocity[numtimes]=distance[numtimes]/FT	
	timex[numtimes]+=FT
end
Function UserAdjust_ContButtonProc(ctrlName) : ButtonControl
	String ctrlName
	DoWindow/K tmp_PauseforCursor				// Kill self
End



function correctimage(numtimes)
	variable numtimes
	wave test
	variable x,y,z,length,n,s,zm,counter
	x = pcsr(a)
	y = qcsr(a)
	z = zcsr(a)
	x=pcsr(a,"celltracker")-3
	y=qcsr(a,"celltracker")-3
	do
			test[x][y][1]=255
			x+=1
			n+=1
	while(n<=6)
	n=0
	do
		test[x][y][1]=255
		y+=1
		n+=1
	while(n<=6)
	x=pcsr(a,"celltracker")-3
	y=qcsr(a,"celltracker")-3
	n=0
	do
		test[x][y][1]=255
		y+=1
		n+=1
	while(n<=6)
	n=0
	do
		test[x][y][1]=255
		x+=1
		n+=1
	while(n<=6)
end

Function makemovie()
 	string mlist
	variable index,m
 	index=1
 	mlist=wavelist("W_*",";","")
 	newmovie/i/F=10/p=moviepath
 	do
 		string movielist = stringfromlist(index,mlist)
 		if(strlen(movielist)==0)
 			break
 		else
 			duplicate/o $(movielist) test
 			wave test=$""
 		 	Appendimage/t test
 		 	doupdate
		 	addmovieframe
 		endif
 		removeimage test
 		index+=1
 	while(1)
 	closemovie
 	playmovie
 end

////////////////////////////BUTTON FUNCTIONS
Function SuccessfulTrack(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			nVar CN=root:cellnumber
			SuccessfulBox()
			CN+=1
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function FailedToTrack(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			Failbox()
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function ManualTrackCell(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			manualtrack()
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function CreateGVariables(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			variable/g root:cellnumber, root:ImageScale,root:frametime,root:numberofframes
			variable/g root:binsize,root:bright,root:dark,root:boxsize,root:movieoftrack
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function AutoTrackCell(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
		setdatafolder root:images
		Wave/Z wA = csrwaveref(A)
		if(!WaveExists(wA))
		DoAlert (0), "Place Cursor A on the cell that\ryou want to try and track\rThen click the button again."
		return -1
		else
			string frames=wavelist("w_*",";","")
			variable count,index
			do
				string nframes=stringfromlist(index,frames)
				if(strlen(nframes)==0)
					break
				else
					count+=1
				endif
				index+=1
			while(1)
//			print count
			Nvar NF=root:numberofframes
			nf=count
//			print nf
			variable cursorxpos,cursorypos
			cursorxpos=pcsr(a)
//			print cursorxpos
			cursorypos=qcsr(a)
			autotrack()
			cursor/C=(65535,0,0)/h=1/I A, w_0000, cursorxpos, cursorypos
			break
		endif
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function MakeAMovie(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			newpath/o/q/z moviepath
			makemovie()
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function RemoveRawData(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			dowindow/k celltracker
			setdatafolder root:images
			killwaves/a
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function CompiledTheData(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
		/////////BETWEEN THESE TWO MARKERS IS THE CODE THAT THE BUTTON USES TO COMPILE VELOCITY DATA
			string savedDF=getdatafolder(1)
			string data="root:CompiledData"
			variable counter,check
			check=datafolderexists(data)
			counter=1
			if(check==0)
				newdatafolder/o $data
			else
			endif
		do
			string cellfolderlist = "root:cell"+num2str(counter)
			string pluscellfolderlist = "root:cell"+num2str(counter+1)
			string vsave="velocity"
			string dsave="tortuosity"
			variable clist=datafolderexists(cellfolderlist)
			variable plist=datafolderexists(pluscellfolderlist)
			if(clist==0&&plist==0)
				break
			else
			setdatafolder cellfolderlist
			wavestats/q velocity
			make/o/n=1 AvgV
			AvgV[0]=v_avg
			duplicate/o AvgV root:CompiledData:$("velocity"+num2str(counter))
			duplicate/o tortuosity root:compileddata:$("tortuosity"+num2str(counter))
			endif
			counter+=1
		while(1)
		setdatafolder data
		string veloc_concatwave="AVG_Velocity"
		string tort_concatwave="AVG_Tortuosity"
		killwaves/z $veloc_concatwave
		killwaves/z $tort_concatwave
		string velocitylist=wavelist("velocity*",";","")
		string tortuositylist=wavelist("tortuosity*",";","")
		concatenate/np velocitylist, $veloc_concatwave
		concatenate/kill/np tortuositylist, $tort_concatwave
		make/o/n=1 AverageOfAllVelocity, StdevOfAllVelocity
		wavestats/q $veloc_concatwave
		averageofallvelocity=v_avg
		Stdevofallvelocity=V_sdev
		setdatafolder savedDF
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

function wholetime(count)
	variable count
	make/o/n=(1) velocity_time
	string mlist=wavelist("velocity*",";","")
	variable index
	
	do
	 	string check=stringfromlist(index,mlist)
	 	if(strlen(check)==0)
	 		break
	 	else
	 		duplicate/o $(check) test
	 		wave test=$""
	 		velocity_time+=test
	 	endif
	 	index+=1
	while(1)
	velocity_time=velocity_time/index
end


Function LoadFolderImages(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			lodfolderimagepanel()
			string folder="root:images"
			variable check=datafolderexists(folder)
			if(check==0)
				newdatafolder/s root:images
			else
				setdatafolder root:images
			endif
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function DisplayFirstImage(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			setdatafolder root:images
			dowindow/k celltracker
			newimage w_0000
			renamewindow graph0 celltracker
			showinfo
			cursor/C=(65535,0,0)/h=1/I A, w_0000,100,100
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

//==================================================================
//BEGIN IGORs CODE FOR LOADING IMAGES ........Function names slightly modified so they won't interfere if you #include <all ip procedures>
Static Function lodImagesInFolder()

	ControlInfo/W=loadFolderPanel fileTypeMenu
	String fileType=S_Value
	String suffix="????"
	strswitch(fileType)
		case "TIFF":
			suffix=".tif"
		break
		
		case "JPEG":
			suffix=".jpg"
		break
		
		case "PNG":
			suffix=".png"
		break
		
		case "BMP":
			suffix=".bmp"
		break
	endswitch
	
	String listAllFiles=indexedfile(diskFolderPath,-1,suffix)
	if(ItemsInList(listAllFiles)<=0)
		doAlert 0,"Could not find files of the specified type."
		return 0
	endif
	
	String fileName
	String waveStr,myStr
	Variable i=0,numImages=0
	Variable renameFlag
	Variable makeStackFlag
	
	ControlInfo/W=loadFolderPanel	RenameCheck
	renameFlag=V_Value
	
	ControlInfo/W=loadFolderPanel StackCheck
	makeStackFlag=V_Value
	
	if(makeStackFlag && renameFlag==0)
		doAlert 0,"Stacking requires a renaming loaded waves sequentially."
		return 0
	endif
	
	String firstWave
	do
		fileName=StringFromList(i,listAllFiles)
		if(strlen(fileName)<=0)
			break
		endif
		ImageLoad/Q/P=diskFolderPath/T=$fileType fileName
		
		if(renameFlag)
			waveStr=StringFromList(0,S_waveNames)
			sprintf myStr,"W_%04d",i
			Rename $waveStr,$myStr
			if(i==0)
				firstWave=myStr
			endif
		endif
		numImages+=1
		i+=1
	while(1)

	if(makeStackFlag)
		ControlInfo/W=loadFolderPanel killWavesCheck
		if(V_value==0)
			ImageTransform stackImages $firstWave
		else
			ImageTransform/K stackImages $firstWave
		endif
	endif
End

//==================================================================

Function lodFolderImagePanel()

	String curDF=GetDataFolder(1)
	SetDataFolder root:
	NewDataFolder/O/S Packages
	NewDataFolder/O/S loadFolderPackage
		String/G folderPath="_none_"
		String/G baseName="wave"
	SetDataFolder curDF

	NewPanel/K=1 /W=(522,44,902,261) as "Load Folder"
	DoWindow/C loadFolderPanel
	SetDrawLayer UserBack
	DrawText 31,65,"Folder Path:"
	Button SetFolderButton,pos={32,15},size={113,20},proc=lodImages#stFolderButtonProc,title="Set Folder"
	TitleBox title0,pos={112,48},size={162,20}
	TitleBox title0,variable= root:Packages:loadFolderPackage:folderPath
	Button lodImagesButton,pos={33,180},size={111,19},proc=lodImages#lodNowButtonProc,title="Load Now"
	PopupMenu fileTypeMenu,pos={34,75},size={102,20},title="File Type:"
	PopupMenu fileTypeMenu,mode=2,popvalue="JPEG",value= #"\"TIFF;JPEG;PNG;BMP\""
	CheckBox RenameCheck,pos={36,105},size={84,14},title="Rename Waves",value= 1
	SetVariable baseNameSetVar,pos={99,122},size={166,15},title="Base Name:"
	SetVariable baseNameSetVar,format="%g"
	SetVariable baseNameSetVar,value= root:Packages:loadFolderPackage:baseName
	CheckBox StackCheck,pos={97,145},size={69,14},title="Make Stack",value= 1
	CheckBox killWavesCheck,pos={176,145},size={111,14},title="Kill Individual Waves"
	CheckBox killWavesCheck,value= 0
	ModifyPanel fixedSize=1
End

//==================================================================

Static Function stFolderButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			NewPath/O/Q/M="Locate Disk Folder"  diskFolderPath
			SVAR folderPath=root:Packages:loadFolderPackage:folderPath
			if(V_flag==0)
				PathInfo diskFolderPath
				folderPath=S_path
			else
				folderPath="_none_"
			endif
		break
	endswitch

	return 0
End

//==================================================================

Static Function lodNowButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			string folder="root:images"
			variable check=datafolderexists(folder)
			if(check==0)
				newdatafolder/s root:images
			else
				setdatafolder root:images
			endif
			lodImages#lodImagesInFolder()
		break
	endswitch

	return 0
End
//END OF IGORS CODE FOR LOADING IMAGES
//==================================================================

Window celltrack() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(336,65,711,657)
	ModifyPanel cbRGB=(16384,48896,65280), frameStyle=4, frameInset=5
	SetDrawLayer UserBack
	DrawText 11,76,"2.)"
	DrawText 17,172,"1.) Choose Track Method (choose one only)"
	SetDrawEnv linethick= 2,dash= 1
	DrawLine 7,124,367,124
	SetDrawEnv fsize= 15,fstyle= 7
	DrawText 116,146,"AUTO TRACK CELLS"
	SetDrawEnv fsize= 15,fstyle= 7
	DrawText 49,24,"IMAGE PREPARATION BEFORE TRACK"
	DrawText 15,215,"2.) Define Tracking Box Size (50 is a good first guess)"
	DrawText 17,264,"3.) Bin Size (defines the area of the darkest or brightest spot)"
	DrawText 165,288,"(odd numbers between 3 and 9)"
	DrawText 16,386,"5.) "
	SetDrawEnv linethick= 2,dash= 1
	DrawLine 6,449,369,449
	SetDrawEnv fsize= 15,fstyle= 7
	DrawText 105,471,"MANUAL TRACK CELLS"
	DrawText 19,498,"1.)"
	DrawText 158,498,"Then follow instructions below graph"
	DrawText 125,388,"Will generate data using cell number above"
	DrawText 11,101,"3.)  Set the Scale and Time"
	DrawText 18,314,"4.) Give the cell you are about to track an unused number,"
	DrawText 35,329,"or leave number alone to overwrite a failed track"
	DrawText 305,350,"Visual "
	DrawText 305,364,"Reminders"
	DrawText 10,49,"1.)"
	DrawText 116,43,"Only click this if numbers are not present in"
	DrawText 116,56,"boxes below, then close and re-open panel"
	DrawText 17,439,"6.)"
	SetDrawEnv linethick= 2,dash= 1
	DrawLine 7,519,368,519
	SetDrawEnv fsize= 15,fstyle= 7
	DrawText 129,541,"INSTRUCTIONS"
	DrawText 38,562,"Click the windows drop down menu, select help windows"
	DrawText 72,577,"and then choose Cell-Tracker Instructions"
	Button button0,pos={30,59},size={110,20},proc=LoadFolderImages,title="Load Images"
	Button button0,fColor=(65280,32512,16384)
	CheckBox check0,pos={74,178},size={72,14},title="Track Dark",variable= Dark
	CheckBox check1,pos={239,179},size={76,14},title="Track Bright",variable= Bright
	SetVariable setvar1,pos={78,223},size={130,16},title="Tracking Box Size"
	SetVariable setvar1,valueColor=(65535,65535,65535),valueBackColor=(0,0,0)
	SetVariable setvar1,value= boxsize
	Button button1,pos={196,329},size={100,20},proc=SuccessfulTrack,title="Successful Track"
	Button button1,labelBack=(65535,65535,65535),fStyle=0,fColor=(65280,32512,16384)
	SetVariable setvar2,pos={79,272},size={80,16},title="Bin Size"
	SetVariable setvar2,valueColor=(65535,65535,65535),valueBackColor=(0,0,0)
	SetVariable setvar2,value= binsize
	Button button2,pos={40,369},size={80,20},proc=AutoTrackCell,title="AutoTrack Cell"
	Button button2,fColor=(65280,32512,16384)
	Button button3,pos={287,59},size={80,20},proc=MakeAMovie,title="Make Movie"
	Button button3,fColor=(65280,32512,16384)
	Button button4,pos={38,481},size={110,20},proc=ManualTrackCell,title="Manual Track Cell"
	Button button4,fColor=(65280,32512,16384)
	SetVariable setvar3,pos={79,331},size={100,16},title="Cell Number"
	SetVariable setvar3,valueColor=(65535,65535,65535),valueBackColor=(0,0,0)
	SetVariable setvar3,value= cellnumber
	SetVariable setvar4,pos={172,84},size={170,16},title="Image Scale um/pixel"
	SetVariable setvar4,valueColor=(65535,65535,65535),valueBackColor=(0,0,0)
	SetVariable setvar4,value= ImageScale
	SetVariable setvar5,pos={162,102},size={180,16},title="Time Between Frames / min"
	SetVariable setvar5,valueColor=(65535,65535,65535),valueBackColor=(0,0,0)
	SetVariable setvar5,value= frametime
	Button button5,pos={29,32},size={80,20},proc=CreateGVariables,title="Create GVars"
	Button button5,fColor=(65280,32512,16384)
	Button button6,pos={196,350},size={100,20},proc=FailedToTrack,title="Failed to Track"
	Button button6,fColor=(0,65280,0)
	Button button7,pos={144,59},size={139,20},proc=DisplayFirstImage,title="Display First Frame/Refresh"
	Button button7,fColor=(65280,32512,16384)
	CheckBox check2,pos={40,394},size={159,14},title="Generate Movie During Track"
	CheckBox check2,variable= movieoftrack
	Button button8,pos={37,423},size={110,20},proc=RemoveRawData,title="Remove Raw Images"
	Button button8,fColor=(65280,32512,16384)
	Button CompileTheData,pos={192,423},size={80,20},proc=CompiledTheData,title="Compile Data"
	Button CompileTheData,fColor=(65280,32512,16384)
EndMacro



